# ExamScheduler - What it is

This app is used to help manage and (near) automate scheduling of exams for various courses that have oral examinations at JTH. It is developed by Mirza Cenanovic as managing more and more student exams became tedious. 

ExamScheduler uses the Google API as a "database" and to manage forms. It uses the Canvas API to generate student data, such as emails. 

![image](GUIv0.2.png)

![image](CoursesConfig.png)

# How it works

1. For each course there is a list of all students, ID'd by their school email. This is the database for sending out emails with sign-up forms for the exams. New students are added automatically by grabbing their info from Canvas. The canvas IDs are set up in the config file.
2. Every exam has an ID in the form of [short name]-[week number]-[year]. Each exam contains information according to the image above.
3. New exams can be created using the GUI by selecting new exam in the dropdown box.
3. The form is autogenerated using a button, after which it can be modified adding e.g., formatting. 
4. The form is emailed to all students in the student list.
5. After the deadline, the schedule is generated using the corresponding button
6. The schedule can then be sent out to the students.

TODO: Remove passed students is done manually still.

# Installaton

Make sure you have python installed, open a terminal and run

Either

```
pip install -r requirements.txt
```

or

```
pip install canvasapi
pip install --upgrade google-api-python-client google-auth-httplib2 google-auth-oauthlib
pip install toml
pip install pywin32
```

pywin32 is used to send emails using outlook, to get around the pesky junk email filters.

1. You need to enable google api and generate OAuth credentials see https://developers.google.com/docs/api/quickstart/python. Put the `credentials.json` file in the project root.
2. Get the Canvas API token and put it in `privateCanvasToken` in the root.

# Running

Either start using ExamScheduler.bat on windows or  run

```
python ExamScheduler.py
```



